    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2005, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * ---------------------
    028     * TimePeriodAnchor.java
    029     * ---------------------
    030     * (C) Copyright 2003, 2005, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * $Id: TimePeriodAnchor.java,v 1.5.2.1 2005/10/25 21:35:24 mungady Exp $
    036     *
    037     * Changes:
    038     * --------
    039     * 30-Jul-2003 : Version 1 (DG);
    040     * 01-Mar-2004 : Added readResolve() method (DG);
    041     *
    042     */
    043
    044    package org.jfree.data.time;
    045
    046    import java.io.ObjectStreamException;
    047    import java.io.Serializable;
    048
    049    /**
    050     * Used to indicate one of three positions in a time period:
    051     * <code>START</code>, <code>MIDDLE</code> and <code>END</code>.
    052     */
    053    public final class TimePeriodAnchor implements Serializable {
    054
    055        /** For serialization. */
    056        private static final long serialVersionUID = 2011955697457548862L;
    057
    058        /** Start of period. */
    059        public static final TimePeriodAnchor START
    060            = new TimePeriodAnchor("TimePeriodAnchor.START");
    061
    062        /** Middle of period. */
    063        public static final TimePeriodAnchor MIDDLE
    064            = new TimePeriodAnchor("TimePeriodAnchor.MIDDLE");
    065
    066        /** End of period. */
    067        public static final TimePeriodAnchor END
    068            = new TimePeriodAnchor("TimePeriodAnchor.END");
    069
    070        /** The name. */
    071        private String name;
    072
    073        /**
    074         * Private constructor.
    075         *
    076         * @param name  the name.
    077         */
    078        private TimePeriodAnchor(String name) {
    079            this.name = name;
    080        }
    081
    082        /**
    083         * Returns a string representing the object.
    084         *
    085         * @return The string.
    086         */
    087        public String toString() {
    088            return this.name;
    089        }
    090
    091        /**
    092         * Returns <code>true</code> if this object is equal to the specified
    093         * object, and <code>false</code> otherwise.
    094         *
    095         * @param obj  the other object.
    096         *
    097         * @return A boolean.
    098         */
    099        public boolean equals(Object obj) {
    100
    101            if (this == obj) {
    102                return true;
    103            }
    104            if (!(obj instanceof TimePeriodAnchor)) {
    105                return false;
    106            }
    107
    108            TimePeriodAnchor position = (TimePeriodAnchor) obj;
    109            if (!this.name.equals(position.name)) {
    110                return false;
    111            }
    112
    113            return true;
    114        }
    115
    116        /**
    117         * Returns a hash code value for the object.
    118         *
    119         * @return The hashcode
    120         */
    121        public int hashCode() {
    122            return this.name.hashCode();
    123        }
    124
    125        /**
    126         * Ensures that serialization returns the unique instances.
    127         *
    128         * @return The object.
    129         *
    130         * @throws ObjectStreamException if there is a problem.
    131         */
    132        private Object readResolve() throws ObjectStreamException {
    133            if (this.equals(TimePeriodAnchor.START)) {
    134                return TimePeriodAnchor.START;
    135            }
    136            else if (this.equals(TimePeriodAnchor.MIDDLE)) {
    137                return TimePeriodAnchor.MIDDLE;
    138            }
    139            else if (this.equals(TimePeriodAnchor.END)) {
    140                return TimePeriodAnchor.END;
    141            }
    142            return null;
    143        }
    144
    145    }